<!DOCTYPE html>
<html lang="en">
<head>
  <title>Linkedin API usage</title>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1">
  <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/css/bootstrap.min.css">
  <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.3.1/jquery.min.js"></script>
  <script src="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/js/bootstrap.min.js"></script>
  <link rel="stylesheet" href="https://www.w3schools.com/w3css/4/w3.css">
  <!-- <link rel="stylesheet" type="text/css" href="../styles/create_post.css"> -->

  <link rel="stylesheet" type="text/css" href="../assets/css/emojionearea.css">

  <script type="text/javascript" src="../assets/js/emojionearea.js"></script>

  <style type="text/css">
    .alert {
       display: none;
    }
  </style>
</head>
<body>

<div class="container">
  <div class="w3-container w3-blue w3-brown">
    <h2>Make a Post on Linkedin</h2>
    <p>Note: Later images/media may be from the Matlab/Python etc. (For this, people should have Partner membership account)</p>
  </div>
  <br>
  <hr>
  <form class="w3-container" name="linkedin-form" id='linkedin-form-id' onsubmit="return getDataToPostOnLinkedIn(event)">
    <!--     
      <p>
          <label>Comment*</label>
          <input class="w3-input" type="text" id='comment' name='comment'>
      </p> 
    --> 
    <p>
      <label>Title</label>
      <input class="w3-input" type="text" id='title' name='title' name="title">
    </p>
    
    <p>
      <label>Description</label>
      <input class="w3-input" type="text" id='description' name='description' spellcheck="true">
    </p>

    <p>
      <label>Submitted Url</label>
      <input class="w3-input" type="text" id="submittedUrl" name="submittedUrl">
    </p>

    <p>
      <label>Submitted image Url</label>
      <input class="w3-input" type="text" id="submittedImageUrl" name="submittedImageUrl" onfocusout="setImage()">
    </p>

    <p>
      <label>Comment*</label>
      <input class="w3-input" type="text" id='comment' name='comment' maxlength="160">
    </p>

    <button class="w3-btn w3-brown" type="submit">Post</button></p>
  </form>
  <br>
  <br>
  <hr>

<div class="row">
  <div class="col-md-6">
      <img style="display: none" id='img' height="600px">
  </div>
  <div class="col-md-6">
      <iframe style="display: none" id='preview' height="600px"></iframe>
  </div>
</div>
  <div class="alert alert-success" id='linkedin-success'>
    <strong>Success!</strong> Indicates a successful or positive action.
  </div>

  <div class="alert alert-danger" id='linkedin-error'>
    <strong>Error!</strong> Something bad happened
  </div>
</div>

<script type="text/javascript">
function postNowOnLinkedIn({
    title, description, 
    submittedUrl, submittedImageUrl,
    comment, visibilityCode='anyone'
  }) {
      const {linkedinAccessToken} = require("../app/secrets");
      // var type = "POST";
      var method = "POST";

      // var url = "http://localhost:8080/users/";
      var url = "https://api.linkedin.com/v1/people/~/shares?format=json"

      // var data = {
      //   "fullname": "Gobline Sendex",
      //   "email": "gobline@gmail.com",
      //   "age": 12
      // };

      // var data = {
      //   "content": {
      //     "title": "How to Have Great People Skills",
      //     "description": "Some people are naturally jovial and great ...",
      //     "submitted_url": "https://www.wikihow.com/Have-Great-People-Skills",
      //     "submitted_image_url": "https://www.wikihow.com/images/thumb/f/f8/Have-Great-People-Skills-Step-1-Version-2.jpg/aid1256051-v4-728px-Have-Great-People-Skills-Step-1-Version-2.jpg.webp"
      //   },
      //   "comment": "It is nice to see you here",
      //   "visibility": {
      //       "code": "anyone"
      //   }
      // };

      // var data = {
      //   "content": {
      //     "title": "How to Have Great People Skills",
      //     "description": "Some people are naturally jovial and great ...",
      //     "submitted-url": "https://www.wikihow.com/Have-Great-People-Skills",
      //     "submitted-image-url": "https://www.wikihow.com/images/thumb/f/f8/Have-Great-People-Skills-Step-1-Version-2.jpg/aid1256051-v4-728px-Have-Great-People-Skills-Step-1-Version-2.jpg.webp"
      //   },
      //   "comment": "It is nice to see you here 2",
      //   "visibility": {
      //       "code": "anyone"
      //   }
      // };

       var data = {
        "content": {
          "title": title,
          "description": description,
          "submitted-url": submittedUrl,
          "submitted-image-url": submittedImageUrl
        },
        "comment": comment,
        "visibility": {
            "code": visibilityCode
        }
      };

      var dataType = "json"; // html, text, xml, script
      // var contentType = "application/x-www-form-urlencoded";
      var contentType = "application/json"

      var headers = {
        "Authorization": `Bearer ${linkedinAccessToken}`,
        "x-li-format": "json",
        "Content-Type": "application/json"
      }

      var success = (data, textStatus, jQxhr) => {
        console.log("Success");
        console.log(data)
        console.log(typeof data);
        alert("Success");
        document.getElementById('linked-success').style.display = 'block';
      };

      var error = (jQxhr, textStatus, errorThrown) => {
        console.log("Error");
        console.log(errorThrown);
        console.log(jQxhr)
        alert(`Error: ${textStatus} | ${errorThrown}`);
        document.getElementById('linkedin-error').style.display = 'block';
      };

      // Final data
      var obj = {
        headers: headers,
        type: method,
        url: url,
        dataType: dataType,
        contentType: contentType,
        data: JSON.stringify(data),
        success: success,
        error: error
      };
      $.ajax(obj);
}


/*
var obj = {
        headers: headers,
        type: method,
        url: url,
        dataType: dataType,
        contentType: contentType,
        data: data,
        success: success,
        error: error
      };
      */

function getDataToPostOnLinkedIn(event) {
  event.preventDefault();

  let everythingIsOk = true;
  let dataArr = $('#linkedin-form-id').serializeArray();

  console.log(dataArr);
  let dataObj = {};
  for(let o of dataArr) {
    dataObj[o.name] = o.value;
  }

  console.log(dataObj);
  postNowOnLinkedIn(dataObj);
  console.log('Done!!!');
}


function activateemojiOneArea() {
  $(document).ready(function() {
    // $("#comment").emojioneArea();

    $("#comment").emojioneArea({
         position: "bottom"
    });
        
    console.log('Emoji support activated');
  });
}
activateemojiOneArea()


function setImage() {
  console.log('Set Image');
  let img = document.getElementById('img');
  img.style.display = "block";
  console.log(url);
  img.src = url;
}

function setPreview() {
  console.log('Set Image');
  let preview = document.getElementById('preview');
  preview.style.display = "block";
  let url = document.getElementById('submittedUrl').value;
  console.log(url);
  preview.src = url;
}
</script>
</body>
</html>